package com.icdif.audio.examples;

import java.awt.Color;
import java.io.FileInputStream;
import java.util.ArrayList;
import java.util.List;

import com.icdif.audio.analysis.FFT;
import com.icdif.audio.graph.PlaybackPlot;
import com.icdif.audio.graph.Plot;
import com.icdif.audio.io.MP3Decoder;

public class ExampleSpectralFlux {

	//public static final String FILE = "/media/LaCie/musica/Metal/Folk Metal/Syg;Ar;Tyr - Beyond The North Winds (2008)/09 Far Away.mp3";

	public static final String FILE = "/media/LaCie/musica/Rock/Nirvana - Greatest Hits/11.Rape me.mp3";
	
	
	
	public static void main(String[] argv) throws Exception {

		MP3Decoder decoder = new MP3Decoder(new FileInputStream(FILE));

		// windows of 1024 samples and a sampling rate of 44100Hz
		FFT fft = new FFT(1024, 44100);

		float[] samples = new float[1024];

		float[] spectrum = new float[1024 / 2 + 1];
		float[] lastSpectrum = new float[1024 / 2 + 1];

		ArrayList<Float> spectralFlux = new ArrayList<Float>();

		// Decodes the audio and calculates the spectral flux.
		// for each spectrum we calculate the difference to the
		// spectrum of the sample window before the current spectrum
		while (decoder.readSamples(samples) > 0) {
			fft.forward(samples);

			System.arraycopy(spectrum, 0, lastSpectrum, 0, spectrum.length);

			System
					.arraycopy(fft.getSpectrum(), 0, spectrum, 0,
							spectrum.length);

			float flux = 0;

			for (int i = 0; i < spectrum.length; i++) {
				float value = (spectrum[i] - lastSpectrum[i]);
				//ignores the negative values
				flux += value < 0 ? 0 : value;
			}

			spectralFlux.add(flux);

		}

		Plot plot = new Plot("Spectral Flux", 1024, 512);
		plot.plot(spectralFlux, 1, Color.red);
		new PlaybackPlot(plot, 1024, new MP3Decoder(new FileInputStream(
				FILE)));

	}

}
